/* $Id: ddcal.h,v 1.11 2015/01/05 06:42:17 fabio Exp fabio $ */

/*
**	Header for calculator program
**/
#ifndef ddcal_h
#define ddcal_h

#include "util.h"
#include "cudd.h"

/*
**	Masks for diagram types.
*/
#define BDD_TYPE 1
#define ADD_TYPE 2

#define isBDD(x)	((x) & BDD_TYPE)
#define isADD(x)	((x) & ADD_TYPE)

#ifdef DDCAL_MAIN
DdManager *manager;
DdNode *lastexp;
int graphics;
int concentrate;
int ddType;
int ddTypeSave;
char *defname[] = {" "};
int noutputs;
char const *onames[100];
DdNode *nodes[100];
#else
extern DdManager *manager;
extern DdNode *lastexp;
extern int graphics;
extern int concentrate;
extern int ddType;
extern int ddTypeSave;
extern char **defname;
extern int noutputs;
extern char **onames;
extern DdNode **nodes;
#endif

#define NSYMS 1000	/* maximum number of symbols */

struct symtab_t {
    char *name;
    DdNode * value;
    int type;
};

struct symtab_t *symlook(char const *, int);
struct symtab_t *exists(char const *, int);
int bddDump(DdManager *, DdNode **, char *, int);
int do_last(char *, int);

#endif
